package dev.shadowsoffire.apotheosis.adventure.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Preconditions;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.compat.AdventureTwilightCompat;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.function.BiFunction;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;

public class OreMagnetBonus extends GemBonus {
  public static final Codec<OreMagnetBonus> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group(gemClass(), (App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.compat.AdventureTwilightCompat.OreMagnetBonus::new));
  }
  
  public OreMagnetBonus(GemClass gemClass, Map<LootRarity, StepFunction> values) {
    super(Apotheosis.loc("twilight_ore_magnet"), gemClass);
    this.values = values;
  }
  
  public InteractionResult onItemUse(ItemStack gem, LootRarity rarity, UseOnContext ctx) {
    BlockState state = ctx.m_43725_().m_8055_(ctx.m_8083_());
    if (state.m_60795_())
      return null; 
    Level level = ctx.m_43725_();
    Player player = ctx.m_43723_();
    player.m_6672_(ctx.m_43724_());
    ((Item)AdventureTwilightCompat.ORE_MAGNET.get()).m_5551_(gem, level, (LivingEntity)player, 0);
    player.m_5810_();
    int cost = ((StepFunction)this.values.get(rarity)).getInt(0.0F);
    ctx.m_43722_().m_41622_(cost, (LivingEntity)player, user -> user.m_21190_(ctx.m_43724_()));
    return super.onItemUse(gem, rarity, ctx);
  }
  
  public Codec<? extends GemBonus> getCodec() {
    return (Codec)CODEC;
  }
  
  public GemBonus validate() {
    Preconditions.checkArgument(!this.values.isEmpty(), "No values provided!");
    return this;
  }
  
  public boolean supports(LootRarity rarity) {
    return this.values.containsKey(rarity);
  }
  
  public int getNumberOfUUIDs() {
    return 0;
  }
  
  public Component getSocketBonusTooltip(ItemStack gem, LootRarity rarity) {
    return (Component)Component.m_237110_("bonus." + getId() + ".desc", new Object[] { Integer.valueOf(((StepFunction)this.values.get(rarity)).getInt(0.0F)) }).m_130940_(ChatFormatting.YELLOW);
  }
}
